
/*

MIDI-to-DMX for keyboard and MIDI song files
Written by Perry Scanlon, Version 2018-02-01
Videos and instructions at Lights4Music.com

You are free to use this code as you wish.  If you create derivative code and release publicly, or if you use in a commercial product, please give credit for the use of this code.  
For full license details, see license.txt contained in this code release.

This code uses the Teensyduino MIDI library which is based on the Arduino MIDI library by 47 Effects (Copyright (c) 2016 Francois Best, http://fortyseveneffects.com/).  
The serial commands used to send DMX are based on this forum discussion thread: https://forum.pjrc.com/threads/28545-DMXSimple-Issues

Tested with Teensy LC and should work with Teensy 3.2 also.  For tips on building MIDI and DMX circuits, see http://lights4music.com/instructions.html  
A good resource for building MIDI circuits is here: https://www.pjrc.com/teensy/td_libs_MIDI.html (remember to adjust resistors for 3.3V).  
And this circuit will work for sending DMX from a 3.3V processor, even though it's designed for 5V: https://playground.arduino.cc/DMX/DMXShield  
This code uses Serial3 TX to send DMX which is pin 8 on Teensy 3.2 and Teensy LC.

Adjust the values in the a_global tab to customize your light show.

To fine-tune the fade off times, you can probably use division instead of bit-shifting and not notice the additional processing time on a 32-bit processor.  
On an 8-bit processor, you might want to use sums or differences of bit-shifted values instead of division, especially if you use this code to write something more complex.

For use with Arduino shields, it may work with the Arduino 101 or Mega, but this has not been tested.  It will probably not work with the Uno because of RAM limitations.  
It may work with a Teensy-to-Arduino shield, but if the shield does not contain level converters you can't use Teensy LC because the 5V MIDI signal would damage the RX input.  
Instead use Teensy 3.2 which is 5V-tolerant and allows use of almost any pin with the DmxSimple library, included with Teensyduino.

To use with USB MIDI instead of 5-pin MIDI, there are different ways to do this, depending on which processor you use:
For Teensy, just replace all MIDI commands with USB MIDI commands, and select Tools > USB Type "MIDI" before loading the sketch.  This is easy, and the library is included in Teensyduino.  
For Arduino Uno, Mega, Micro, and Leonardo see this page:  https://github.com/tttapa/MIDI_controller
For Arduinos with 32-bit processors (e.g. ARM chips) see this page: https://www.arduino.cc/en/Reference/MIDIUSB

*/

